package ProjectTankHard.Generics;

import ProjectTankHard.DrawningObjects.DrawningTankBase;
import ProjectTankHard.DrawningObjects.IDraw;
import ProjectTankHard.Entities.EntityTankBase;

import java.util.Random;

public class HardGeneric <T extends EntityTankBase, U extends IDraw>{
    T[] firstArray;
    U[] secondArray;
    private int currentSize;
    private int CountFirst;
    private int CountSecond;
    private int pictureBoxWidth;
    private int pictureBoxHeight;
    public HardGeneric(int countFirst, int countSecond, int width, int height){
        currentSize = 0;
        CountFirst = countFirst;
        CountSecond = countSecond;
        firstArray = (T[]) new EntityTankBase[CountFirst];
        secondArray = (U[]) new IDraw[CountSecond];
        pictureBoxHeight = height;
        pictureBoxWidth = width;
    }
    public int InsertFirst(T entityTankBase){
        if(firstArray[CountFirst - 1] != null) return -1;

        for(int i = currentSize - 1; i >= 0; i--) {
            firstArray[i + 1] = firstArray[i];
            secondArray[i + 1] = secondArray[i];
        }

        currentSize++;
        firstArray[0] = entityTankBase;

        return 0;
    }
    public int InsertSecond(U inter){
        if(secondArray[CountSecond-1] != null) return -1;

        secondArray[0] = inter;
        return 0;
    }
    public DrawningTankBase MakeObject(){
        Random rand = new Random();
        int indFirst = rand.nextInt(0, currentSize);
        EntityTankBase entity = firstArray[indFirst];
        DrawningTankBase tank = new DrawningTankBase(entity.Speed(), entity.Weight(), entity.BodyColor(),
                pictureBoxWidth, pictureBoxHeight);
        return tank;
    }
}
